; Include for Task_Keys line ~75
;   176+    
; #ifdef	W1_Pin
; movlw	Write_W1_Sensor; d'15' ;     1-Wire; 
; subwf	Encoder_Count,W,ACCESS;
; bnz	EpromSyncSet
;        
;#include Proj_Dir\1W\1-Write_SensorNum.INC	;     
;	bra		DoneButt			;    
;EpromSyncSet
; #endif
;

;18F4550_39632a.pdf 6.4 Erasing Flash Program Memory 
;The minimum erase block is 32 words or 64 bytes
;   8   1-Ware 
;When initiating an erase sequence from the microcontroller
;itself, a block of 64 bytes of program memory
;is erased. The Most Significant 16 bits of the
;TBLPTR<21:6> point to the block being erased.
;TBLPTR<5:0> are ignored.
;      64  -   W1_ProgPageBuf	
;  :  CRC=0      -       - 
;   -  .
		W1_Page	;      
 movf	DS1820_CRC,W,BANKED				; 
 bnz	LocalSubRouteSkip				; 

 rcall	LoadTblPtr_1W ;      
;	movlf	0xC0,TBLPTRL,ACCESS	;  
;	movlf	0x7F,TBLPTRH,ACCESS	;   
;	movlf	0x00,TBLPTRU,ACCESS	;  
  lfsr	0,W1_ProgPageBuf	; 

	movlf	d'64',W1_Byte_Count,BANKED	;     - 64 .

LoopPageTransfer	;     
	tblrd*+	;     
	movff	TABLAT,POSTINC0	;    
	decfsz	W1_Byte_Count,F,BANKED	;
		bra	$-8	;    
;		bra	LoopPageTransfer;  

	 movff	FSR1H,W1_TempInt+0	;  1      
	 movff	FSR1L,W1_TempInt+1	; 

 lfsr	0,W1_ProgPageBuf	;   8  
 lfsr	1,DS1820_ScratctPad	;     

	decf	W1_SensorWriteNumber,W,BANKED	;	  
		bnc	SkipAdd_Adr
	mullw	0x8		;      1   
	Add16	FSR0L,ACCESS,PRODL,ACCESS	; 
;	movf	PRODL,W,ACCESS	;  	
;	addwf	FSR0L,F,ACCESS	;   
SkipAdd_Adr

	movlf	d'8',W1_Byte_Count,BANKED	;     - 8 .

LoopSensorTransfer	;     
;	tblrd*+	;     
	MOVF POSTINC1,W,ACCESS	
	MOVWF POSTINC0,ACCESS ;       

;	movff	POSTINC1,POSTINC0	;     
	decfsz	W1_Byte_Count,F,BANKED	;
		bra	$-6	;    
;		bra	LoopSensorTransfer;  

	 movff	W1_TempInt+0,FSR1H	;  1      
	 movff	W1_TempInt+1,FSR1L	; 

;     -   

 movf	W1_SensorWriteNumber,W,BANKED	; 	
 bz		LocalSubRouteSkip				; 


	BCF INTCON, GIEH, ACCESS ; disable interrupts
	BCF INTCON, GIEL, ACCESS ; disable interrupts
	clrwdt					 ;
	bcf	WDTCON,SWDTEN,ACCESS ;	 

 rcall	LoadTblPtr_1W ;      
 BSF EECON1, EEPGD,ACCESS ; point to Flash program memory
 BCF EECON1, CFGS,ACCESS ; access Flash program memory
 BSF EECON1, WREN,ACCESS ; enable write to memory

; movlw MaxW1Sensors+1	;    
; subwf	W1_SensorWriteNumber,W,BANKED;	
; bnz	EpromSync		;   1  
;;    64  = 8 
EraseProgMem
;   AN851 bootload.asm
;ERASE_ROW ;EXAMPLE 6-2: ERASING A FLASH PROGRAM MEMORY ROW
 
 BSF EECON1, FREE,ACCESS ; enable Row Erase operation

;	movlw	b'10010100'		; Setup writes
;	movwf	EECON1,ACCESS	;
;		extern	StartWrite 
		rcall	StartWrite		; Erase the row
; 7. The CPU will stall for duration of the erase
; (about 2 ms using internal timer).

; ****   .88   4550 **** 
  TBLRD*- ; dummy read decrement
	lfsr	0,W1_ProgPageBuf	; 

	rcall	Prog_Mem	;    32 

	rcall	Prog_Mem	;    32 

SkipWriteSensor
	clrwdt							;
	bsf		WDTCON,SWDTEN,ACCESS	;	 
	BSF INTCON, GIEH, ACCESS ; re-enable interrupts High
	BSF INTCON, GIEL, ACCESS ; re-enable interrupts Low
	bra	LocalSubRouteSkip

Prog_Mem	;    32 

	movlf	d'32',W1_Byte_Count,BANKED	;     - 64 .
LoopPageWrite	;      
;WRITE_BYTE_TO_HREGS
	MOVF POSTINC0,W,ACCESS ; get low byte of buffer data
	MOVWF TABLAT,ACCESS ; present data to table latch
	TBLWT+* ; write data, perform a short write
; to internal TBLWT holding register.
;	tblrd*+	;     
;	movff	TABLAT,POSTINC0	;    
	decfsz	W1_Byte_Count,F,ACCESS	;
		bra	$-8	;    
;		bra	LoopPageWrite;  

;PROGRAM_MEMORY
 BSF EECON1, EEPGD ; point to Flash program memory
 BCF EECON1, CFGS ; access Flash program memory
 BSF EECON1, WREN ; enable write to memory
	rcall	StartWrite		; Write the row
 BCF EECON1, WREN ; disable write to memory

		retlw	0x0

; *****************************************************************************
;   AN851 bootload.asm
; Unlock and start the write or erase sequence.
;	global	StartWrite;
StartWrite ; rcall
		clrwdt					;
	movlf	0x55,EECON2,ACCESS	; Unlock
	movlf	0xAA,EECON2,ACCESS	; sequence
	bsf	EECON1,WR,ACCESS		; Start the write
		nop

		retlw	0x0
; *****************************************************************************


LoadTblPtr_1W ; rcall
	movlf	0xC0,TBLPTRL,ACCESS	;  
	movlf	0x7F,TBLPTRH,ACCESS	;   
	movlf	0x00,TBLPTRU,ACCESS	;  
		retlw	0x0

LocalSubRouteSkip