;   Define.h  ~49
; #include Proj_Dir\Cfg\V3_Cfg1.inc	;       
;    3.02,    LCD = R/W,
;      .

; #define NotEpromParamProg		No	;      \EPROM\EPROM_Data.inc 

;   Define_PCPWM_3F.inc

 #define SetTermistorOutput		bcf TRISA,0,ACCESS	;   
 #define SetTermistorInput		bsf TRISA,0,ACCESS	;   


;   Table_1W.inc
SN_Ds18B20	macro	;   
		db	d'0',d'3'	;     
#ifdef PCPWM_Board ;       
		db	0x28,0x16,0xBF,0xED,0x09,0x00,0x00,0x8D	;   5
		db	0x28,0x16,0xBF,0xED,0x09,0x00,0x00,0x8D	;   5
		db	0x28,0x16,0xBF,0xED,0x09,0x00,0x00,0x8D	;   5
;		db	0x28,0x47,0x51,0xEE,0x09,0x00,0x00,0x64	;   1
;		db	0x28,0x59,0x20,0xED,0x09,0x00,0x00,0x04	;   2
;		db	0x28,0x5B,0x76,0x39,0x01,0x00,0x00,0x49	;   0724C3-422AE    
#else ;       - , , 
		db	0x28,0x16,0xBF,0xED,0x09,0x00,0x00,0x8D	;   5
		db	0x28,0x16,0xBF,0xED,0x09,0x00,0x00,0x8D	;   5
		db	0x28,0x16,0xBF,0xED,0x09,0x00,0x00,0x8D	;   5
;		db	0x28,0x4C,0x70,0x39,0x01,0x00,0x00,0x0B	;   0724C3-422AE    
#endif
	endm			;

WorkScreens	macro	;  LCD_Text_FA.inc
;*************************     0 ***************************
Msg7	;     10   ,   .
 db	d'39',HexUByte1ch	;     
	dw	Tic_10;       3  

 db SendByte2CmdReg,d'72',DecSWordTemp6ch;
  	dw	Adc_Volt+2				;  IRAMX
 db SendByte2CmdReg,d'71',"T="	;    ?

 #ifdef	PCPWM_12b;	 Yes	; 12    8  -   
	db SendByte2CmdReg,d'19' ;   
 	db HexUWord4ch;;   Hex - 4 
 #else ;#ifdef	PCPWM_12b;
	db SendByte2CmdReg,d'20' ;   
 	db HexUByte2ch;   Hex - 2 
 #endif ;#ifdef	PCPWM_12b;
	dw PCPWM_AmpSin ;   

	db	DecSWordTemp6ch	;
   dw	Adc_Volt+0		;  0
 	db "V"				;

 db SendByte2CmdReg,d'84' ; ******  *****  
 db SubStringOut,0	; 4    + 
    dw LCD_4_Buf;,F,BANKED;    4 

 #ifdef	W1_Pin ; ******  *****  
  db SendByte2CmdReg,d'78',DecSWordTemp6ch		;,
 dw DS1820_ScratctPad1+0	;     
  db SendByte2CmdReg,d'64',DecSWordTemp6ch		;,
 dw DS1820_ScratctPad1+2 ;   ,0x19,DS1820_ScratctPad1+4 ;,0; 10 byte
  db "," 					;
 #endif ; #ifdef	W1_Pin

  db SendByte2CmdReg,d'7',SubStringOut,0	; + 
 dw PCPWM_AnimeSubStr	;;   
  db SubStringOut,0		; + 
 dw PCPWM_ForwardReverse;

 	db 0 ;  

Msg8;  ************     1 = 10    ***************

 db	d'39',HexUByte1ch	;     
	dw	Tic_10;       3  

 db SendByte2CmdReg,d'00',"  ="
 db ParamRegulate,0x31,0xFF, HexUByte2ch ;
  dw	PCPWM_Accelerate ;,F,BANKED;   
 db " "			;


 db SendByte2CmdReg,d'72',DecSWordTemp6ch;
  	dw	Adc_Volt+2				;  IRAMX
 db SendByte2CmdReg,d'71',"T="	;    ?

;						   
;
;	db	HexUByte2ch		;
; dw	ADC_Out+5	;  -1
; 	db " "			;
;
;	db	HexUByte2ch		;
; dw	ADC_Out+7	;  -1
; 	db " "			;

		db SendByte2CmdReg,d'84' ;   
;    SubStringOut 
 db SubStringOut,0	; 4    + 
    dw LCD_4_Buf;,F,BANKED;    4 

 #ifdef	W1_Pin
  db SendByte2CmdReg,d'78',DecSWordTemp6ch		;,
 dw DS1820_ScratctPad1+0	;     
  db SendByte2CmdReg,d'64',DecSWordTemp6ch		;,
 dw DS1820_ScratctPad1+2 ;   ,0x19,DS1820_ScratctPad1+4 ;,0; 10 byte
  db "," 					;
 #endif ; #ifdef	W1_Pin
 
 	db 0 ;  

;*************************     2 ***************************
Msg9	;     10   ,   2.
 db	d'39',0x18	;   
	dw	Tic_10;       3  

 db SendByte2CmdReg,d'00'," ="
 db ParamRegulate,0x21,0xFF, HexUByte2ch ;
  dw	Par_A ;,F,BANKED;   
 db " "			;

 db SendByte2CmdReg,d'72',DecSWordTemp6ch;
  	dw	Adc_Volt+2				;  IRAMX
 db SendByte2CmdReg,d'71',"T="	;    ?

		db SendByte2CmdReg,d'84' ;   
;    SubStringOut 
 db SubStringOut,0	; 4    + 
    dw LCD_4_Buf;,F,BANKED;    4 

 #ifdef	W1_Pin
  db SendByte2CmdReg,d'78',DecSWordTemp6ch		;,
 dw DS1820_ScratctPad1+0	;     
  db SendByte2CmdReg,d'64',DecSWordTemp6ch		;,
 dw DS1820_ScratctPad1+2 ;   ,0x19,DS1820_ScratctPad1+4 ;,0; 10 byte
  db "," 					;
 #endif ; #ifdef	W1_Pin
 
 	db 0, ;  


	endm


;   Define_1W.inc
;   1-
; #ifdef	PORTD	;4431
#define W1_TRIS			TRISC
#define W1_Lat			LATC
#define W1_Port			PORTC
#define W1_Pin			0	; 15  4431
; #else			;2431
;#define W1_TRIS			TRISC
;#define W1_Lat			LATC
;#define W1_Port			PORTC
;#define W1_Pin			7	; 18  2431
; #endif
;
#define W1_Clear		bcf	W1_Lat,W1_Pin,ACCESS
#define W1_Set			bsf	W1_Lat,W1_Pin,ACCESS
#define W1_Output		bcf	W1_TRIS,W1_Pin,ACCESS
#define W1_Input		bsf	W1_TRIS,W1_Pin,ACCESS

; ;   Define_Beeper.inc
;   Beeper
; Pin and port:
#ifdef	PORTD	;4431
 #define Beeper_TRIS	TRISD
 #define Beeper_Lat		LATD
 #define Beeper_Port	PORTD
 #define Beeper_Pin		4
#else			;2431
;  2
; #define Beeper_TRIS	TRISC
; #define Beeper_Lat		LATC
; #define Beeper_Port	PORTC
; #define Beeper_Pin		6	; RC6 = Beeper

;  3
 #define Beeper_TRIS	TRISA
 #define Beeper_Lat		LATA
 #define Beeper_Port	PORTA
 #define Beeper_Pin		6	; RA6 = Beeper
#endif

#define BeeperPin	 	Beeper_Lat,Beeper_Pin,ACCESS
;#define BeeperOutPut 	bsf	Beeper_TRIS,Beeper_Pin,ACCESS
; Macros for sound:
#define Beeper_Output	bcf	Beeper_TRIS,Beeper_Pin,ACCESS
;#define Beeper_Input		bsf	Beeper_TRIS,Beeper_Pin,ACCESS
;#define Beeper_Clear		bcf	BeeperPin
;#define Beeper_Set		bsf	BeeperPin
#define Beeper_Toggle	btg	BeeperPin
#define Beeper_TrisTogl	btg	Beeper_TRIS,Beeper_Pin,ACCESS




;        -  
 #define Fault_TempMon	ADC_Out+0	;N0 =  2 = 
 #define I_DC	ADC_Out+4	;N2 =  4 =    DC 
 #define U_DC	ADC_Out+2	;N1 =  3 =   DC 
 #define SensorInput ADC_Out+6	;N3 =  5 =  /  QEA
;     .
 #define I_DC_Zero	d'8000' ;d'2621' ; 0xFFFF/25	; ~1/25=0.2V        

;      -      .
;   ADC_Step.inc  ~151
; FXM0808SL	Adc_Corr+2,bnk,d'13';     ""
; Add16L PRODL,acs,0x1eff*0x8;   495=0x1ef   F 
; FXM1616U2 ADC_Work+0,bnk	,ADC_Out+4,bnk	,PRODL,acs,	ADC_Work+7,bnk;
; RShift16_N	ADC_Work+2,bnk,3	; 3   2 
; movff_N ADC_Work+2,Adc_Volt+2,2;   -    

 #define I_DC_RevCnt	d'3' ;	;      
 #define I_DC_MulCorr	d'61' ;	;     ""
;  ""   ,   
;      .

;  30,  ~9.6 ,   ~10 , 5 , 32*16  :
;    1/4    ,     
;     50,    ~ 30 
; I_DC_AddCorr       -    .
 #define I_DC_AddCorr	d'42921';d'26767' ; =512*5/0.096   5/0,096     512
 #define I_DC_ShiftCorr 5; RShift16_N ADC_Work+2,bnk,5	; 1   2  -  7  2  -   ,   .
 #define AnSens_SubZero	d'13107';   .  1  = 65536/5 = 13107
 #define AnSens_MulZero	d'13';     ""
 #define AnSens_MulCorr	d'43';     ""
 #define AnSens_AddCorr	d'49555';         
 #define AnSens_ShiftCorr 5	; 21    = 16 ( 2 ) + 5  2  

;   -      
 #define Key_Up			PortB_Buf,0,ACCESS	;  ++
 #define Key_Down		PortB_Buf,2,ACCESS	;  ++
 #define Key_Left		PortB_Buf,4,ACCESS	;  ++   
 #define Key_Right		PortB_Buf,1,ACCESS	;  ++
 #define Key_E_Up		PortB_Buf,6,ACCESS	; .   ++ 
 #define Key_E_Down		PortB_Buf,7,ACCESS	; .   ++ 
 #define Key_Encoder	PortB_Buf,5,ACCESS ;  	++
 #define Key_EncMask	andlw	b'00100000';    

 #define Encoder_B0	Encoder_Bits,6,BANKED ; 0 
 #define Encoder_B1	Encoder_Bits,7,BANKED ; 1 

;  SpeedChange_2    :
#define DoubleFreqKey	Key_Right	; PortB_Buf,4,ACCESS	; 
#define HalfFreqKey	 	Key_Left	; PortB_Buf,3,ACCESS	; 
#define Mem_0_Key		Key_Up		; PortB_Buf,1,ACCESS	;   
#define Mem_1_Key		Key_Down	; PortB_Buf,2,ACCESS	;  
#define RevRunKey	Key_E_Down		; Encoder_Buf,7,BANKED;PortB_Buf,7,ACCESS	;   7F 
#define ForwRunKey	Key_E_Up		; Encoder_Buf,6,BANKED;PortB_Buf,6,ACCESS;    BF 

;  SpeedChange_3     -:
;#define RevRunKey	Encoder_Buf,7,BANKED;PortB_Buf,7,ACCESS	;   7F 
;#define ForwRunKey	Encoder_Buf,6,BANKED;PortB_Buf,6,ACCESS;    BF 


EncoderBitsInput	Macro	;      -    
 movb	LCD_Key_Port0,	Encoder_Bits,7,BANKED ; Encoder_B1; 
 movb	LCD_Key_Port2,	Encoder_Bits,6,BANKED ; Encoder_B0; 
	endm

KeysRow1Input	Macro	;  2     
 movb	LCD_Key_Port2,	PortB_Buf,7,ACCESS ; Key_E_Down	; 
 movb	LCD_Key_Port0,	PortB_Buf,6,ACCESS ; Key_E_Up	; 
 movb	LCD_Key_Port1,	PortB_Buf,4,ACCESS ; Key_Left	;   -  
	endm

KeysRow2Input	Macro	;  3   -    .
 movb	LCD_Key_Port2,PortB_Buf,3,ACCESS ;     
 movb	LCD_Key_Port2,	PortB_Buf,2,ACCESS ; Key_Down	;   
 movb	LCD_Key_Port1,	PortB_Buf,1,ACCESS ; Key_Right	; 
 movb	LCD_Key_Port0,	PortB_Buf,0,ACCESS ; Key_Up		;   
	endm

;#define LED0_Pin 		6
	#ifdef	LED0_Pin
#define LED0_PORT 		LATB
#define LED0_TRIS 		TRISB
#define Debug_LED0		LED0_PORT,LED0_Pin,ACCESS
#define LED0_Output	bcf	LED0_TRIS,LED0_Pin,ACCESS
#define LED0_Set	bcf	Debug_LED0	;   +5 
#define LED0_Clear	bsf	Debug_LED0	; 
#define LED0_Toggle	btg	Debug_LED0
	#else
#define LED0_Output	nop
#define LED0_Set	nop
#define LED0_Clear	nop
#define LED0_Toggle	nop
	#endif


;#define LED1_Pin 		7
	#ifdef	LED1_Pin
#define LED1_PORT 		LATB
#define LED1_TRIS 		TRISB
#define Debug_LED1		LED1_PORT,LED1_Pin,ACCESS
#define LED1_Output	bcf	LED1_TRIS,LED1_Pin,ACCESS
#define LED1_Set	bsf	Debug_LED1
#define LED1_Clear	bcf	Debug_LED1
#define LED1_Toggle	btg	Debug_LED1
	#else
#define LED1_Output	nop
#define LED1_Set	nop
#define LED1_Clear	nop
#define LED1_Toggle	nop
	#endif


 #define LCD_Present	Proj_Dir\LCD_Key_Enc\Lcd_Drv2431_4.inc	;YES	;    
 #include Proj_Dir\LCD_Key_Enc\Lcd_Def2431_4.inc	;      .
